/****************************************************************
 *
 * int MIDI_SharpFlatAdjust(int keySig, int MIDInum)
 *
 * Arguments: keySig: 1-7 = sharps, 0 = no sharps or flats
 *               -1..-7 = flats
 *
 * Return value: Sharp or Flat corrected MIDI number
 *
 * This function adds or subtracts one based on if it needs to be
 *   sharped or flatted.
 *
 *****************************************************************/

int 
MIDI_SharpFlatAdjust(int keySig, int MIDInum)
{
  int i = 0;
  int temp = 0;
  int check = 0;
  printf("Adjusting for key signature... \n");
  printf("MIDInum = %d, keySig = %d\n",MIDInum,keySig);

  if (keySig == 0){
    return MIDInum;
  }
  else{
    printf("HELLO\n");
	while(check == 0){
      if ((MIDInum % (CNOTE + (12 * i)) == 0) && (MIDInum / (CNOTE + (12 * i)) == 1)){
        temp = CNOTE;
		printf("Cnote..., i = %d\n",i);
		check = 1;
      }
      else if((MIDInum % (BNOTE + (12 * i)) == 0) && (MIDInum / (BNOTE + (12 * i)) == 1)){
        temp = BNOTE;
		printf("Bnote...\n");
		check = 1;
      }
      else if((MIDInum % (ANOTE + (12 * i)) == 0) && (MIDInum / (ANOTE + (12 * i)) == 1)){
        temp = ANOTE;
		printf("Anote...\n");
		check = 1;
      }
      else if((MIDInum % (GNOTE + (12 * i)) == 0) && (MIDInum / (GNOTE + (12 * i)) == 1)){
        temp = GNOTE;  
		printf("Gnote...\n");
		check = 1;
	  } 
      else if((MIDInum % (FNOTE + (12 * i)) == 0) && (MIDInum / (FNOTE + (12 * i)) == 1)){
        temp = FNOTE;
        printf("Fnote..i = %d\n",i);
		check = 1;
      }
      else if((MIDInum % (ENOTE + (12 * i)) == 0) && (MIDInum / (ENOTE + (12 * i)) == 1)){
        temp = ENOTE;
		printf("Enote...\n");
		check = 1;
      }
      else if((MIDInum % (DNOTE + (12 * i)) == 0) && (MIDInum / (DNOTE + (12 * i)) == 1)){
        temp = DNOTE;
		printf("Dnote...\n");
		check = 1;
      }
	  i++;
    }

    if (keySig == 1 && temp == FNOTE){
      return MIDInum + 1;
    }
    else if (keySig == 2 && (temp == FNOTE || temp == CNOTE)){
      return MIDInum + 1;
    }
    else if (keySig == 3 && (temp == FNOTE || temp == CNOTE || temp == GNOTE)){
      return MIDInum + 1;
    }
    else if (keySig == 4 && (temp == FNOTE || temp == CNOTE || temp == GNOTE ||
                                 temp == DNOTE)){
      return MIDInum + 1;
    }
    else if (keySig == 5 && (temp == FNOTE || temp == CNOTE || temp == GNOTE ||
                                 temp == DNOTE || temp == ANOTE)){
      return MIDInum + 1;
    } 
    else if (keySig == 6 && (temp == FNOTE || temp == CNOTE || temp == GNOTE ||
                                 temp == DNOTE || temp == ANOTE || temp == ENOTE)){
      return MIDInum + 1;
    }
    else if (keySig == 7 && (temp == FNOTE || temp == CNOTE || temp == GNOTE ||
                temp == DNOTE || temp == ANOTE || temp == ENOTE || temp == BNOTE)){
      return MIDInum + 1;
    }
	/*Checking for flats here...*/
	else if (keySig == -1 && temp == BNOTE){
      return MIDInum - 1;
    }
    else if (keySig == -2 && (temp == BNOTE || temp == ENOTE)){
      return MIDInum - 1;
    }
    else if (keySig == -3 && (temp == BNOTE || temp == ENOTE || temp == ANOTE)){
      return MIDInum - 1;
    }
    else if (keySig == -4 && (temp == BNOTE || temp == ENOTE || temp == ANOTE ||
                                 temp == DNOTE)){
      return MIDInum - 1;
    }
    else if (keySig == -5 && (temp == BNOTE || temp == ENOTE || temp == ANOTE ||
                                 temp == DNOTE || temp == GNOTE)){
      return MIDInum - 1;
    } 
    else if (keySig == -6 && (temp == BNOTE || temp == ENOTE || temp == ANOTE ||
                                 temp == DNOTE || temp == GNOTE || temp == CNOTE)){
      return MIDInum - 1;
    }
    else if (keySig == -7 && (temp == BNOTE || temp == ENOTE || temp == ANOTE ||
                temp == DNOTE || temp == GNOTE || temp == CNOTE || temp == FNOTE)){
      return MIDInum - 1;
    }

  }

  return MIDInum;
}

/****************************************************************
 *
 * int MIDI_NumAssign(int position, int keySig, int cleff)
 *
 * Arguments: position on staff from bottom staff line
 *            key signature: 1-7 = sharps, 0 = no sharps or flats
 *               -1..-7 = flats
 *            cleff: 1 = treble, -1 = bass
 *
 * Return value: MIDI number for note passed
 *
 * This function will find the corresponding MIDI number for 
 *   for a note that is passed to it based on its cleff, key signature,
 *   and position on the staff.
 *
 *****************************************************************/

int 
MIDI_NumAssign(int position, int keySig, int clef)
{
	int temp = 0;
	int dir = 0;
	int i = 0;
	int j = 0;
	int counter = 0;

	printf("Key Sig: %d\n",keySig);

	if (position >= 0){
		dir = UP;
	}
	else{
		dir = DOWN;
		position = position * -1;
    }

	if (clef == 1){
		temp = MID_E;
	}
	else{
		temp = LOW_E;
	}

	printf("temp initial: %d\n",temp);

  for (j = (position / 7); j >= 0 ; j--){
		if (j == 0){
			counter = position % 7;
		}
		else{
			counter = 7;
		}
	if (dir == UP){

      for (i = 0; i < counter; i++){
	    if ((i == 0) || (i == 4)){
	      temp++;
		  /*printf("temp 1: %d\n",temp);*/
	    }
	    else{
		  temp++;
		  temp++;
		 /* printf("temp 2: %d\n",temp);*/
	    }
	  }
	}
	else if (dir == DOWN){
      for (i = 0; i < counter; i++){
	    if ((i == 2) || (i == 6)){
	      temp--;
	    }
	    else{
		  temp--;
		  temp--;
		}
	  }
	}
  }
  
  /*call sharps and flats adjust...*/
  temp = MIDI_SharpFlatAdjust(keySig,temp);
  printf("temp final: %d\n\n\n",temp);
  
  return temp;
}

/*********************************************************
 *
 * IMS_Build.c
 *
 * Authors: Ben McQuiston
 *
 * C function that writes the header created from the image parameter
 *  function that the user defines through the LCD.  Creates the IMS.
 * 
 * Last Revision: 
 *       - November 28, 2006
 *  
 *****************************************************************/
void
IMS_Build(int *header)
{
  int i;
  FILE *fp1;
  fp1 = fopen("output.ims","w");
  if (fp1 == NULL){
	  printf("Error in opening IMS output for writing");
  }

  for (i = 0; i < 5; i++){
  fprintf(fp1,"%c",(char)header[i]);
  }

  fclose(fp1);
}
/*********************************************************
 *
 * IMS_Append.c
 *
 * Authors: Ben McQuiston
 *
 *  Called from the Note Analyzer, just writes two bytes corresponding
 *  to a given note from the image.  Appends the IMS each time.
 *  
 * Last Revision: 
 *       - November 28, 2006
 *  
 *****************************************************************/
void
IMS_Append(int *header, int position, int noteLen)
{
  int keySig,clef;
  int temp;
  FILE *fp1;
  fp1 = fopen("output.ims","a");
  if (fp1 == NULL){
	  printf("Error in opening IMS output for writing");
  }

  keySig = header[1];
  clef = header[5];

  temp = MIDI_NumAssign(position,keySig,clef);

  fprintf(fp1,"%c",(char)(temp & 0x000000FF));
  fprintf(fp1,"%c",(char)(noteLen & 0x000000FF));

  fclose(fp1);

}

