/*	+-------------------------------------------------------------------------------------------------------------------------------+
	| Interface Compact Flash / PIC + FAT16 avec un PIC18F452																		|																							|
	+-------------------------------------------------------------------------------------------------------------------------------+
	| Copyright (C) 2005 Charles RINCHEVAL (charles.r@digitalspirit.org)															|
	+-------------------------------------------------------------------------------------------------------------------------------+
	| Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence Publique Gnrale GNU 	|
	| publie par la Free Software Foundation (version 2 ou bien toute autre version ultrieure choisie par vous).					|
	| Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,					|
	| y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.											|
	| Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.														|
	| Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme, si ce n'est pas le cas,	|
	| crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis. 					|
	+-------------------------------------------------------------------------------------------------------------------------------+

	Todo :
	- Possible optimisation du chargement des cluster dans fat_load_file_cluster
	- Pouvoir compiler en dsactivant le systme de cache
	- FAT_Bpb.bytsPerSec ou 512 en dr ???
	- Support des disques partitionns
	- ATTENTION, on ne supporte pas les fichiers suprieurs  4Go...!

 */

#include "fat16.h"

/*
#pragma varlocate "BIG_BUFF" FAT_CurrentSector, FAT_CurrentByte

extern unsigned long	FAT_CurrentSector;
extern unsigned long	FAT_CurrentByte;
*/

//char FatCurrentPath[FAT_MAX_PATH];

//#pragma udata FAT_C_UDATA
#pragma code	FAT_C_CODE


/*	Initialisations diverses
 */
void fat_init(void) {
	
	int i;
#ifndef WRITE_ENABLED
	unsigned int sbuf0, sbuf1;
#endif

/*
	memset(&FatCurrentPath, 0x00, sizeof(FatCurrentPath));

	FatCurrentPath[0] = FAT_SEPARATOR;
	FatCurrentPath[1] = 0x00;	//'d';
	FatCurrentPath[2] = 'o';
	FatCurrentPath[3] = 's';
	FatCurrentPath[4] = 's';
	FatCurrentPath[5] = 'i';
	FatCurrentPath[6] = 'e';
	FatCurrentPath[7] = 'r';
	FatCurrentPath[8] = 0x00;
*/

	// La BPB propre, c'est mieux !
	memset(&FAT_Bpb, 0x00, sizeof(FAT_Bpb));

	// Recherche du dbut
//	cf_set_position(0, 1);
//	cf_write_reg(CF_REG_COMMAND, CF_CMD_READ_SECTOR);

//	cf_skip8(0xE3);
//	cf_skip8(0xE3);

//	FAT_StartSector = (unsigned long)cf_read16();

	FAT_StartSector = 0;

	cf_set_position(FAT_StartSector, 1);

#ifndef WRITE_ENABLED

	cf_write_reg(CF_REG_COMMAND, CF_CMD_READ_SECTOR);

	// Chargement de la structure BPB
	FAT_Bpb.jmpBoot[0] = cf_read8();
	FAT_Bpb.jmpBoot[1] = cf_read8();
	FAT_Bpb.jmpBoot[2] = cf_read8();

	for (i = 0; i < 8; i++)
		FAT_Bpb.OEMName[i] = cf_read8();

	FAT_Bpb.bytsPerSec = cf_read16();
	FAT_Bpb.secPerClus = cf_read8();
	FAT_Bpb.rsvdSecCnt = cf_read16();
	FAT_Bpb.numFATs = cf_read8();
	FAT_Bpb.rootEntCnt = cf_read16();
	FAT_Bpb.toSec16 = cf_read16();

	FAT_Bpb.media = cf_read8();
	FAT_Bpb.FATSz16 = cf_read16();
	FAT_Bpb.seePerTrk = cf_read16();
	FAT_Bpb.numHeads = cf_read16();

	sbuf0 = cf_read16();
	sbuf1 = cf_read16();
	FAT_Bpb.hiddSec = ((long)sbuf1 << 16) | sbuf0;

	sbuf0 = cf_read16();
	sbuf1 = cf_read16();
	FAT_Bpb.totSec32 = ((long)sbuf1 << 16) | sbuf0;


	FAT_Bpb.drvNum = cf_read8();
	FAT_Bpb.reserved = cf_read8();

	FAT_Bpb.bootSig = cf_read8();

	sbuf0 = cf_read16();
	sbuf1 = cf_read16();
	FAT_Bpb.volID = ((long)sbuf1 << 16) | sbuf0;	

	for (i = 0; i < 8; i++)
		FAT_Bpb.volLab[i] = cf_read8();

	for (i = 0; i < 8; i++)
		FAT_Bpb.filSysType[i] = cf_read8();

#else

	/*	Si le buffer existe, autant faire comme a, a va plus vite ...
		... et a prend moins de place !
	 */
	cf_buffer_load();
	memcpy(&FAT_Bpb, &BK_Buffer, sizeof(FAT_Bpb));

#endif

	FAT_StartSector = FAT_StartSector + FAT_Bpb.rsvdSecCnt;
//	FAT_RootDirCountSectors = ((FAT_Bpb.rootEntCnt * 32) + FAT_Bpb.bytsPerSec - 1) / FAT_Bpb.bytsPerSec;

	// L'adresse du root directory (ATTR_VOLUME_ID)
	FAT_RootDirStartSector = FAT_StartSector + FAT_Bpb.numFATs * FAT_Bpb.FATSz16;

	// L'adresse du premier secteur o on peut lire des donnes !
	FAT_FirstDataSector = FAT_RootDirStartSector + ((FAT_Bpb.rootEntCnt * 32) + FAT_Bpb.bytsPerSec - 1) / FAT_Bpb.bytsPerSec;

	// Occupation totale de la FAT !
//	FatSize = ((long)FAT_Bpb.bytsPerSec * (long)FAT_Bpb.FATSz16);


	fat_load_file_cluster(2);
	FAT_CurrentSector = 0;

	DEBUGF("FAT initialisation OK!");
}


/*	Charge le cache d'un fichier !
	@param numCluster Chargement  partir de ce numro de cluster
 */
void fat_load_file_cluster(unsigned int numCluster) {

	unsigned int offset = 0;
	unsigned int i, value = 0;

	// Nettoyage du cache
	for (i = 0; i < FAT_CACHE_SIZE; i++)
		FAT_Cache[i] = 0x0000;

	// Positionnement sur le bon secteur
	fat_start_addr(FAT_StartSector, FAT_MODE_READ);

	// Chargement du cache
	for (i = 0; i < FAT_CACHE_SIZE; i++) {

		for (; offset < (numCluster + 1); offset++) {
			value = fat_get_word();
		}

		numCluster = value;

		if (value == 0xFFFF)
			break;
		else if (value == 0x00 || value == FAT_BAD_CLUSTER) {
			return FAT_ERROR;
		}

		FAT_Cache[i] = value;
	}

	FAT_CacheOffset = 0;

	return;
}


/*	Retourne le cluster suivant
	@param cluster Cluster dbut
	@return Retourne le cluster suivant ou 0 en cas d'erreur
 */
unsigned int fat_get_next_cluster() {

	unsigned int ret;

	ret = FAT_Cache[FAT_CacheOffset];

	if (FAT_Cache[FAT_CacheOffset] != 0x00) {
		FAT_CacheOffset++;
		if (FAT_CacheOffset >= FAT_CACHE_SIZE) {
			DEBUGF("Rechargement du cache cluster de fichier");
			fat_load_file_cluster(FAT_Cache[FAT_CACHE_SIZE - 1]);
		}
	} else
		ret = 0x00;

	DEBUGF("Current cluster : %i;", ret);

	return ret;
}


/*	Retourne le nombre de clusters libre
 */
unsigned int fat_find_free_clusters(void) {

	unsigned char j;
	unsigned int freeclusters, i, fatentry;
	
	for (i = 0; i < FAT_Bpb.FATSz16; i++) {
		fat_start_addr(FAT_StartSector + i, FAT_MODE_READ);
		for (j = 0; j < 256; j++) {
			fatentry = fat_get_word();
			if (fatentry == 0x00) {
				freeclusters++;
			}
		}
	}

	return freeclusters;
}


/*	Retourne le premier cluster libre
 */
unsigned int fat_get_first_free_cluster() {

	unsigned char j;
	unsigned int i, fatentry;
	
	for (i = 0; i < FAT_Bpb.FATSz16; i++) {
		fat_start_addr(FAT_StartSector + i, FAT_MODE_READ);
		for (j = 0; j < 256; j++) {
			fatentry = fat_get_word();
			if (fatentry == 0x0000) {
				return (i ? i : 1) * (j ? j : 1);
			}
		}
	}
}


#ifdef WRITE_ENABLED

/*	Fait point dans la FAT le pointeur dsir vers le cluster !
	@param uint p Le pointeur
	@param uint cluster Le cluster voulu
 */
void fat_set_cluster(unsigned int p, unsigned int cluster) {

	unsigned char j;
	unsigned int i, fatentry, num = 1;

	unsigned int sec;
	unsigned char offset;

	/*	Tout d'abord, on calcul  quel secteur...
		... se trouve le cluster demand
	 */
//	sec = p / (FAT_Bpb.bytsPerSec / 2);
//	offset = (p - FAT_Bpb.bytsPerSec) + 2;

	sec = FAT_Bpb.rsvdSecCnt + ((p * 2) / FAT_Bpb.bytsPerSec);
	offset = ((p * 2) % FAT_Bpb.bytsPerSec);

	// On charge le buffer
	fat_start_addr(sec, FAT_MODE_READ);
	cf_buffer_load();

	// On se positionne et on crit dans le buffer
	BK_Buffer[offset] = *(((char*)&cluster) + 0);
	BK_Buffer[offset + 1] = *(((char*)&cluster) + 1);

	// Et enfin, on crit le secteur correctement modifi !
	fat_start_addr(sec, FAT_MODE_WRITE);
	cf_buffer_flush();	
}

#endif


/*	Spcifie une adresse lba et une commande (READ or WRITE)
	@param lba L'adresse Logical Block Adressing
	@param mode Mode d'ouverture (lecture ou criture)
 */
void fat_start_addr(unsigned long lba, unsigned char mode) {
	FAT_CurrentByte = 0;
	FAT_CurrentSector = lba;
	cf_set_position(lba, 1);
	cf_write_reg(CF_REG_COMMAND, ((mode) ? CF_CMD_WRITE_SECTOR : CF_CMD_READ_SECTOR));
}


/*	Converti un cluster en secteur
	@param cluster Le cluster !
	@return Le secteur gal
 */
unsigned long fat_cluster_2_sector(unsigned int cluster) {

	unsigned long sector = 0;

	sector = cluster - 2;
	sector *= (unsigned long)FAT_Bpb.secPerClus;
	sector += (unsigned long)FAT_FirstDataSector;

	return sector;
}


/*	Supprime un ou plusieurs secteurs
	@param lba Adresse de dbut
	@param nbr_sector Nombre de secteur
 */
void fat_erase_sector(unsigned long lba, unsigned char nbr_sector) {
	FAT_CurrentByte = 0;
	FAT_CurrentSector = lba;
	cf_set_position(lba, nbr_sector);
	cf_write_reg(CF_REG_COMMAND, CF_CMD_ERASE_SECTOR);
}


/*	Permet de rcuprer la Directory Entry Structure aprs un fat_start_addr(lba)
	@return Retourne 0 si pas d'erreur
 */
char fat_load_directory_entry() {

	char ret = FAT_OK;
	int i;
	unsigned short sbuf0, sbuf1;

_fat_load_directory_entry_goto0:
	FAT_DirEntry.name[0] = fat_get_byte();
	
	if (FAT_DirEntry.name[0] == 0x00)
		return FAT_END_OF_DIR;
	
	for (i = 1; i < 11; i++)
		FAT_DirEntry.name[i] = fat_get_byte();
	FAT_DirEntry.attr = fat_get_byte();

	// Si l'entre est un nom de fichier long, on skip la suite !
	if (FAT_DirEntry.attr == ATTR_LONG_NAME) {
		fat_skip_byte(20);
		goto _fat_load_directory_entry_goto0;	// tu sais ce que je pense des goto ??
	}

	FAT_DirEntry.NTRes = fat_get_byte();
	FAT_DirEntry.crtTimeTenth = fat_get_byte();
	FAT_DirEntry.crtTime = fat_get_word();
	FAT_DirEntry.crtDate = fat_get_word();
	FAT_DirEntry.lstAccDate = fat_get_word();
	FAT_DirEntry.fstClusHI = fat_get_word();
	FAT_DirEntry.wrtTime = fat_get_word();
	FAT_DirEntry.wrtDate = fat_get_word();
	FAT_DirEntry.fstClusLO = fat_get_word();

	sbuf0 = fat_get_word();
	sbuf1 = fat_get_word();
	FAT_DirEntry.filSize = ((long)sbuf1 << 16) | sbuf0;

	return ret;
}


#ifdef WRITE_ENABLED

/*	Ecrit la structure globale FAT_DirEntry dans la directory entry
 */
void fat_set_directory_entry(FatFile *file) {

	unsigned int i = 0;

	fat_start_addr(file->dirEntrySector, FAT_MODE_READ);
	cf_buffer_load();

	i = ((int)file->dirEntryNum * 0x10);

	FAT_DirEntry.filSize = file->size;
	FAT_DirEntry.fstClusLO = file->startCluster;

	memcpy(&BK_Buffer[i], &FAT_DirEntry, sizeof(FatDirEntry));

	fat_start_addr(file->dirEntrySector, FAT_MODE_WRITE);
	cf_buffer_flush();
}

#endif


/*	Monte d'un seul rpertoire
	@param path Le chemin voulu (null termin)
 */
void fat_cd_one_dir(char *path) {

	char ret;
	int i;
	unsigned long sector;
//	char path[FAT_MAX_PATH] = "dossier/suite";
	char bufferr[13];

	while (1) {
		ret = fat_load_directory_entry();
		if (ret == FAT_END_OF_DIR)
			break;
		memset(&bufferr, 0x00, sizeof(bufferr));
		fat_get_filename(FAT_DirEntry.name, &bufferr);
		if (FAT_DirEntry.attr == ATTR_DIRECTORY && !memcmp(bufferr, path, strlen(path))) {
			sector = fat_cluster_2_sector(FAT_DirEntry.fstClusLO);
			fat_start_addr(sector, FAT_MODE_READ);
			fat_skip_byte(0x40);
			break;
		}
	}
}


/*	Se positionne sur le rpertoire voulu
	@param path Le chemin voulu
	@return Retourne > 0 si le chemin  t trouv
 */
char fat_cd(char* pathh) {

	char ret;
	int i = 0;
	int icnt;
	char buff0[FAT_MAX_PATH];
	char buff1[13];
	unsigned long sector;

	fat_start_addr(FAT_RootDirStartSector, FAT_MODE_READ);

	// Si on demande le root ou rien
	if (pathh[0] == FAT_SEPARATOR && pathh[1] == 0x00 || pathh[0] == 0x00)
		return FAT_OK;

	if (pathh[i] == FAT_SEPARATOR)
		i++;

	while (pathh[i] != 0x00) {
		icnt = 0;
		memset(buff0, 0x00, sizeof(buff0));
	
		while (i < FAT_MAX_PATH) {
			if (pathh[i] == FAT_SEPARATOR || pathh[i] == 0x00) {

				while (1) {
					ret = fat_load_directory_entry();
					if (ret == FAT_END_OF_DIR)
						return FAT_INEXISTANT_FILE;
					memset(&buff1, 0x00, sizeof(buff1));
					fat_get_filename(FAT_DirEntry.name, &buff1);
					if (FAT_DirEntry.attr & ATTR_DIRECTORY && !strcmp(buff1, buff0)) {
						sector = fat_cluster_2_sector(FAT_DirEntry.fstClusLO);
						fat_start_addr(sector, FAT_MODE_READ);
						fat_skip_byte(0x40);
						break;
					}
				}

				if (pathh[i] == 0x00 || (pathh[i] == '/' && pathh[i + 1] == 0x00))
					return FAT_OK;

				i++;
				break;
			}

			buff0[icnt] = pathh[i];
			i++;
			icnt++;
		}
	}

	return FAT_INEXISTANT_FILE;
}


/*	Ouvre un fichier, rempli la structure tFile
	@param filename Le fichier  ouvrir dans le rpertoire courant
	@param *tFile La structure  remplir
	@param mode Le mode d'ouverture 0 pour lecture sinon criture
 */
char fat_open_file(unsigned char *filename, FatFile *tFile, unsigned char mode) {
	
	char ret = FAT_OK;
	char cbuffer[13];
	unsigned long sector;

	while (1) {
		ret = fat_load_directory_entry();
		if (ret == FAT_END_OF_DIR)
			return FAT_INEXISTANT_FILE;

		memset(&cbuffer, 0x00, sizeof(cbuffer));
		fat_get_filename(FAT_DirEntry.name, &cbuffer);
		if (!strcmp(strupr(cbuffer), strupr(filename))) {

			tFile->currentByte = 0;
			tFile->size = FAT_DirEntry.filSize;
			tFile->startCluster = FAT_DirEntry.fstClusLO;
			tFile->currentCluster = FAT_DirEntry.fstClusLO;

			tFile->dirEntrySector = FAT_CurrentSector;
			tFile->dirEntryNum = (FAT_CurrentByte / 0x10) - 2;

			fat_load_file_cluster(tFile->startCluster);

			sector = fat_cluster_2_sector(tFile->startCluster);
			fat_start_addr(sector, mode);
			break;
		}
	}

	return ret;
}


/*	Skip !
	@param nbr Nombre d'octets  "skipper"
 */
void fat_skip_byte(unsigned int nbr) {

	for (; nbr > 0; nbr--) {
		if (FAT_CurrentByte == FAT_Bpb.bytsPerSec) {
			fat_start_addr(++FAT_CurrentSector, FAT_MODE_READ);
		}
		cf_skip8(1);
		FAT_CurrentByte++;
	}
}


/*	Ici, on vient lire l'octet suivant !
 */
unsigned char fat_get_byte() {

	if (FAT_CurrentByte == FAT_Bpb.bytsPerSec) {
		fat_start_addr(++FAT_CurrentSector, FAT_MODE_READ);
	}
	FAT_CurrentByte++;
	return cf_read8();
}


/*	Ici, on vient lire l'octet suivant !
 */
unsigned int fat_get_word() {

	unsigned char buf0, buf1;

	buf0 = fat_get_byte();
	buf1 = fat_get_byte();

	return ((int)buf1 << 8) | buf0;
}


/*	Renvoie un caractre (s'utilise  la suite d'un fat_open_file)
 */
char fat_get_next_byte(FatFile *tFile) {

	int cmpt;
	unsigned char ch;
	unsigned int cluster;
	unsigned long sector;

	cmpt = tFile->currentByte & 1023;		// Plus lger qu'un modulo
	cmpt++;

	ch = fat_get_byte();
	tFile->currentByte++;

	// Paf, notre pointeur  atteint 1024 octets, changement de cluster
	if (cmpt == 1024) {
		cluster = fat_get_next_cluster();
		if (cluster) {
			tFile->currentCluster = cluster;
			sector = fat_cluster_2_sector(cluster);
			fat_start_addr(sector, FAT_MODE_READ);
		}
	}

	return ch;
}


#ifdef WRITE_ENABLED

/*	Cr un nouvelle entre dans le chemin courant
	@param filename Le nom !
	@param *tFile La structure  remplir
	@param attrib Les attributs voulus
*/
char fat_create_entry(unsigned char *filename, FatFile *tFile, unsigned char attrib) {
//char fat_create_entry(unsigned char *filename, unsigned char attrib) {

	char ret = FAT_OK;
	unsigned int offset = 0;
	unsigned int i = 0;
	unsigned int isector = 0;

	unsigned char buffilename[11];

	while (1) {
		
		for (i = 0; i < 512; i++) {
			BK_Buffer[i] = fat_get_byte();
		}


		offset = 0;

		// Lecture et recherche dans le buffer
		for (; offset < BK_BUFFER_SIZE;) {
			
			if (BK_Buffer[offset] == 0x00 || BK_Buffer[offset] == FAT_FILE_DELETED) {
				
				fat_format_filename(filename, &buffilename);
				memcpy(&FAT_DirEntry.name, &buffilename, 11);

				FAT_DirEntry.attr = attrib | ATTR_ARCHIVE;
				FAT_DirEntry.NTRes = 0x18;

				FAT_DirEntry.crtTimeTenth = 0x51;
				FAT_DirEntry.crtTime = 0x7592;

				FAT_DirEntry.crtDate = 0x328E;
				FAT_DirEntry.lstAccDate = 0x328E;

				FAT_DirEntry.fstClusHI = 0x00;	// Tjrs 0 pour FAT16

				FAT_DirEntry.wrtTime = 0x80E8;
				FAT_DirEntry.wrtDate = 0x3268;

				FAT_DirEntry.fstClusLO = 0x0000;
				FAT_DirEntry.filSize = 0x00000000;
/*
				tFile.currentByte = 0;
				tFile.size = 0;
				tFile.startCluster = 0;
				tFile.currentCluster = 0;
*/
				tFile->dirEntrySector = FAT_RootDirStartSector + isector;
				tFile->dirEntryNum = (offset / 0x10);

				memcpy(&BK_Buffer[offset], &FAT_DirEntry, sizeof(FatDirEntry));

				cf_set_position(FAT_RootDirStartSector + isector, 1);
				cf_buffer_flush();

				return ret;

			} else
				offset = offset + 32;

		}

		isector++;

	}

	return ret;
}

#endif


/*	Ecrit le buffer dans le secteur spcifi
	@param sector Le secteur voulue
 */
/*
void fat_write_buffer_2_sector(unsigned long sector) {

	unsigned int i;

	fat_start_addr(sector, FAT_MODE_WRITE);
	for (i = 0; i < 512; i++)
		cf_write(sectorBuffer[i]);
}
*/


/*	Renvoie le nom du fichier suivi de son extension au format 8.+3
	@param name Le champs name de la Fat Dir Entry
	@param buf Le buffer de minimum 13 octets o stocker le rsultat
 */
void fat_get_filename(char name[11], char *buf) {

	unsigned int i, ii;
//	unsigned char name[12] = "essai.txt"; 

	// On s'occupe du nom (8) ...
	for (i = 0; i < 8; i++) {
		if (name[i] == 0x20)
			break;
		buf[i] = tolower((int)name[i]);
	}

	// ... et de l'extension
	if (name[8] != FAT_SPACE && name[9] != FAT_SPACE && name[10] != FAT_SPACE) {
		buf[i] = '.';
		for (ii = 8; ii < 11; ii++) {
			buf[++i] = tolower((int)name[ii]);
		}
	}
}


/*	Remplace les caractres interdit comme il faut...
	@param c La caractre qui va bien
 */
unsigned char fat_char_2_dos(unsigned char c)
{
	switch(c) {
		// KANJI pour les japonais
		case 0xE5:
			c = 0x05;
			break;
		case 0x22:
		case 0x2A:
		case 0x2B:
		case 0x2C:
		case 0x2E:
		case 0x3A:
		case 0x3B:
		case 0x3C:
		case 0x3D:
		case 0x3E:
		case 0x3F:
		case 0x5B:
		case 0x5C:
		case 0x5D:
		case 0x7C:
			c = '_';
			break;
		default:
			c = (c <= 0x20) ? 0 : toupper((int)c);
			break;
	}
	return c;
}


/*	Formate le nom du fichier pour tre crit dans la FAT
	@param in Sous la forme "file.txt" en entre
	@param out donne "FILE    TXT" en sortie
 */
void fat_format_filename(char in[12], char *out) {

	unsigned char i, ext = 0;

	for (i = 0; i < 11; i++) {
		if (in[i] == 0) {
			for (; i < 11; i++)
				out[i] = 0x20;
			break;
		}

		if (in[i] == '.')
			ext = i;
		out[i] = (ext) ? 0x20 : fat_char_2_dos(in[i]);
	}

	if (ext) {
		ext++;
		for (i = 8; i < 11; ext++, i++)
			out[i] = fat_char_2_dos(in[ext]);
	}

	return;
}


/*	Affiche le nom du fichier suivi de son extension au format 8.+3
	@param buf Le buffer de minimum 13 octets o stocker le rsultat
 */
void fat_print_filename() {//char *name) {

	unsigned int i, ii = 0;

	char buf[13];
	memset(&buf, 0x20, sizeof(buf));

	for (i = 0; i < 8; i++) {
		if (FAT_DirEntry.name[i] == 0x20)
			break;
		buf[i] = FAT_DirEntry.name[i];
	}

	if (FAT_DirEntry.name[8] != FAT_SPACE && FAT_DirEntry.name[9] != FAT_SPACE && FAT_DirEntry.name[10] != FAT_SPACE) {
		buf[i] = '.';
		for (ii = 8; ii < 11; ii++) {
			buf[++i] = FAT_DirEntry.name[ii];
		}
	}

	buf[12] = 0x00;
	printf("%13s", buf);
}


/*	Affiche la date et l'heure sous forme de string (DD/MM/YYYY HH:MM)
	@param date
	@param time
	@param timeTenth
 */
/*
void fat_print_time(unsigned int date, unsigned int time, unsigned char timeTenth) {

	char mins, hours;

	char day, month;
	int year;

	mins = (char)((time >> 5) & 0x003F);
	hours = (char)((time >> 11) & 0x001F);

	day = (char)(date & 0x001F);
	month = (char)((date >> 5) & 0x000F);
	year = (int)((date >> 9) & 0x007F);

	printf("%0.2d/%0.2d/%4d %0.2dh%0.2d ", day, month, (1980 + year), hours, mins);
}
*/
