/********************************************************
 *  WINBOND W569 MIDDLEWARE DEFINE FILE
 *
 *  FILENAME:
 *    Define.h
 *
 *  MODIFICATION HISTORY:
 *    2004/08/02	created		by	CCChien0
 ********************************************************/
#define	_W569_SPEC	0x017

#define WTB_ROM_START_ADDR		0x800000

#define CMD_COM_IRQE			0x80

#if	_W569_SPEC	>= 0x016

	#define CMD_STA_BUSY			0x01
	#define CMD_STA_S_EMP			0x02
	#define CMD_STA_X_RDY			0x04
	#define CMD_STA_S_FUL			0x08
	#define CMD_STA_P_EMP			0x10
	#define CMD_STA_P_FUL			0x20
	#define CMD_STA_G_EMP			0x40
	#define CMD_STA_Y_RDY			0x80

	#define	CMD_COM_ID_SEQ_FIFO		0x00	// Write
	#define	CMD_COM_ID_X_BUF		0x00	// Read
	#define	CMD_COM_ID_WAKE_UP		0x01	// R/W
	#define	CMD_COM_ID_CLK_CTRL		0x02	// R/W
	#define	CMD_COM_ID_FIFO_RT_REG		0x03	// Write
	#define	CMD_COM_ID_Y_BUF		0x03	// Read
	#define	CMD_COM_ID_INT_ST_REG		0x04	// R/W
	#define	CMD_COM_ID_SPE_FIFO		0x05	// Write
	#define CMD_COM_ID_FIFO_STAT_REG	0x05	// Read
	#define CMD_COM_ID_FIFO_ST_REG		0x06	// R/W
	#define	CMD_COM_ID_OP_CTRL		0x07	// R/W
	#define	CMD_COM_ID_GEN_FIFO		0x08	// Write
	#define	CMD_COM_ID_ST_REG		0x08	// Read
	#define	CMD_COM_ID_SPK_VOL_REG		0x09	// R/W
	#define	CMD_COM_ID_PLL_ST_REG_I		0x0a	// R/W
	#define	CMD_COM_ID_PLL_ST_REG_II	0x0b	// R/W
	#define	CMD_COM_ID_ANALOG_CTRL		0x0c	// R/W
	#define	CMD_COM_ID_INT_EN_REG		0x0d	// R/W
	#define CMD_COM_ID_EQ_VOL_REG		0x0e	// R/W
	#define CMD_COM_ID_HEADPHONE_VOL_L_REG	0x0f	// R/W
	#define CMD_COM_ID_HEADPHONE_VOL_R_REG	0x10	// R/W
	#define COD_COM_ID_PLL_CHARGE_PUMP_REG	0X11	// R/W


	#define IRQ_STA_REG_FIS0		0x01
	#define IRQ_STA_REG_SFIS		0x02
	#define IRQ_STA_REG_FIS2		0x04
	#define IRQ_STA_REG_FIS3		0x08
	#define IRQ_STA_REG_TBIS		0x10
	#define IRQ_STA_REG_TAIS		0x20
	#define IRQ_STA_REG_PFIS		0x40
	#define IRQ_STA_REG_FIS1		0x80

	#define IRQ_EN_REG_FIE0			0x01
	#define IRQ_EN_REG_SFIE			0x02
	#define IRQ_EN_REG_FIE2			0x04
	#define IRQ_EN_REG_FIE3			0x08
	#define IRQ_EN_REG_TBIE			0x10
	#define IRQ_EN_REG_TAIE			0x20
	#define IRQ_EN_REG_PFIE			0x40
	#define IRQ_EN_REG_FIE1			0x80

	#define	WAKE_UP_REG_INT			0x01
	#define	WAKE_UP_REG_DP0			0x02

	#define FIFO_RT_REG_RST			0x01
	#define FIFO_RT_REG_SFRT		0x02
	#define FIFO_RT_REG_GFRT		0x04
	#define FIFO_RT_REG_PFRT		0x08

	#define	CLK_CTRL_REG_DP1		0x01
	#define CLK_CTRL_REG_AP2		0x02

	#define	ANALOG_CTRL_REG_AP7		0x01	// W56940 & W56964
	#define ANALOG_CTRL_REG_AP1		0x04
	#define	ANALOG_CTRL_REG_AP0		0x08
	#define	ANALOG_CTRL_REG_AP3		0x10	// W56940 & W56964
	#define	ANALOG_CTRL_REG_AP4		0x20	// W56940 & W56964
	#define	ANALOG_CTRL_REG_AP5		0x40	// W56940 & W56964
	#define	ANALOG_CTRL_REG_AP6		0x80	// W56940 & W56964

	#define	FIFO_STAT_REG_SLET		0x01
	#define	FIFO_STAT_REG_PLET		0x02

#else

	#define CMD_STA_BUSY			0x01
	#define CMD_STA_G_EMP			0x02
	#define CMD_STA_S_EMP			0x04
	#define CMD_STA_S_FUL			0x08
	#define CMD_STA_P_EMP			0x10
	#define CMD_STA_P_FUL			0x20
	#define CMD_STA_X_RDY			0x40
	#define CMD_STA_Y_RDY			0x80

	#define CMD_COM_ID_INT_ST_REG		0x00
	#define CMD_COM_ID_INT_EN_REG		0x01
	#define CMD_COM_ID_NONE			0x02
	#define CMD_COM_ID_GEN_FIFO		0x03
	#define CMD_COM_ID_SEQ_FIFO		0x04
	#define CMD_COM_ID_SPE_FIFO		0x05
	#define CMD_COM_ID_X_BUF		0x06
	#define CMD_COM_ID_Y_BUF		0x07
	#define CMD_COM_ID_FIFO_ST_REG		0x08
	#define CMD_COM_ID_FIFO_RT_REG		0x09
	#define CMD_COM_ID_PLL_ST_REG_I		0x0a
	#define CMD_COM_ID_PLL_ST_REG_II	0x0b
	#define CMD_COM_ID_SPK_VOL_REG		0x0c
	#define CMD_COM_ID_PWR_MGN_REG		0x0d
	#define CMD_COM_ID_OP_CTRL		0x0e
	#define CMD_COM_ID_RSV1			0x0f

	#define IRQ_STA_REG_FIS0		0x01
	#define IRQ_STA_REG_FIS1		0x02
	#define IRQ_STA_REG_FIS2		0x04
	#define IRQ_STA_REG_FIS3		0x08
	#define IRQ_STA_REG_TBIS		0x10
	#define IRQ_STA_REG_TAIS		0x20
	#define IRQ_STA_REG_PFIS		0x40
	#define IRQ_STA_REG_SFIS		0x80

	#define IRQ_EN_REG_FIE0			0x01
	#define IRQ_EN_REG_FIE1			0x02
	#define IRQ_EN_REG_FIE2			0x04
	#define IRQ_EN_REG_FIE3			0x08
	#define IRQ_EN_REG_TBIE			0x10
	#define IRQ_EN_REG_TAIE			0x20
	#define IRQ_EN_REG_PFIE			0x40
	#define IRQ_EN_REG_SFIE			0x80

	#define FIFO_RT_REG_RST			0x01
	#define FIFO_RT_REG_GFRT		0x02
	#define FIFO_RT_REG_SFRT		0x04
	#define FIFO_RT_REG_PFRT		0x08

	#define PWR_MGN_REG_AP0			0x01
	#define PWR_MGN_REG_AP1			0x02
	#define PWR_MGN_REG_AP2			0x04
	#define PWR_MGN_REG_DP1			0x40
	#define PWR_MGN_REG_DP0			0x80

#endif

#define FIFO_ST_REG_SDIRQ_0	0x00
#define FIFO_ST_REG_SDIRQ_32	0x01
#define FIFO_ST_REG_SDIRQ_64	0x02
#define FIFO_ST_REG_SDIRQ_96	0x03
#define FIFO_ST_REG_SDIRQ_128	0x04
#define FIFO_ST_REG_SDIRQ_160	0x05
#define FIFO_ST_REG_SDIRQ_192	0x06
#define FIFO_ST_REG_SDIRQ_224	0x07

#define FIFO_ST_REG_SDIRQ_2_0	0x00
#define FIFO_ST_REG_SDIRQ_2_64	0x01
#define FIFO_ST_REG_SDIRQ_2_128	0x02
#define FIFO_ST_REG_SDIRQ_2_192	0x03
#define FIFO_ST_REG_SDIRQ_2_256	0x04
#define FIFO_ST_REG_SDIRQ_2_320	0x05
#define FIFO_ST_REG_SDIRQ_2_384	0x06
#define FIFO_ST_REG_SDIRQ_2_448	0x07

#define FIFO_ST_REG_CASD	0x08

#define FIFO_ST_REG_PDIRQ_0	0x00
#define FIFO_ST_REG_PDIRQ_32	0x10
#define FIFO_ST_REG_PDIRQ_64	0x20
#define FIFO_ST_REG_PDIRQ_96	0x30
#define FIFO_ST_REG_PDIRQ_128	0x40
#define FIFO_ST_REG_PDIRQ_160	0x50
#define FIFO_ST_REG_PDIRQ_192	0x60
#define FIFO_ST_REG_PDIRQ_224	0x70

#define OPC_REG_OPT0		0x01
#define OPC_REG_OPT1		0x02
#define OPC_REG_OPT2		0x04
#define OPC_REG_OPT3		0x08
